; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "SoftEther VPN Client"
!define PRODUCT_VERSION "4.08"
!define PRODUCT_PUBLISHER "SoftEther"
!define PRODUCT_WEB_SITE "https://www.softether.org/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\vpnclient.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\modern-uninstall.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; MUI end ------
; Use to get command line parameters (silent)
!include "FileFunc.nsh"
!insertmacro GetParameters
!insertmacro GetOptions

!include "x64.nsh"

; Command line parameters
Var /GLOBAL VPN_SERVER
Var /GLOBAL VPN_PORT
Var /GLOBAL VPN_HUB
Var /GLOBAL VPN_CONNECTION
Var /GLOBAL VPN_LOGIN
Var /GLOBAL VPN_PASSWORD
Var /GLOBAL SOFTETHER_VPNCLIENT
Var /GLOBAL REBOOT_AFTER_INSTALL

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "softether-silent-install.exe"
RequestExecutionLevel admin
InstallDir "$PROGRAMFILES64\SoftEther VPN Client"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""

ShowInstDetails show
ShowUnInstDetails show

Function .onInit
  ;;;;;;;;;;;;;;;;;;;;;;;
  ; Command line params ;
  ;;;;;;;;;;;;;;;;;;;;;;;
  ${GetParameters} $R0

  ${GetOptions} $R0 /S $0
  ${If} ${Errors} ; "Silent mode" flag not set
    SetSilent normal
  ${Else} ; "Silent mode" flag set
    SetSilent silent
  ${EndIf}
 
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_SERVER option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_SERVER=" $0
  StrCpy $VPN_SERVER $0
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_PORT option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_PORT=" $0
  StrCpy $VPN_PORT $0
  ${If} $VPN_PORT == ""
    StrCpy $VPN_PORT "443"
  ${EndIf}
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_HUB option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_HUB=" $0
  StrCpy $VPN_HUB $0
  ${If} $VPN_HUB == ""
    StrCpy $VPN_HUB "PULSE"
  ${EndIf}
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_CONNECTION option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_CONNECTION=" $0
  StrCpy $VPN_CONNECTION $0
  ${If} $VPN_CONNECTION == ""
    StrCpy $VPN_CONNECTION "pulse2connection"
  ${EndIf}
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_LOGIN option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_LOGIN=" $0
  StrCpy $VPN_LOGIN $0
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /VPN_PASSWORD option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 "/VPN_PASSWORD=" $0
  StrCpy $VPN_PASSWORD $0
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ; Handle /REBOOT option ;
  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  ${GetOptions} $R0 /R $0
  ${If} ${Errors} ; not set
    StrCpy $REBOOT_AFTER_INSTALL false 
  ${Else}
    StrCpy $REBOOT_AFTER_INSTALL true 
  ${EndIf}
 
  ${If} ${RunningX64}
    StrCpy $SOFTETHER_VPNCLIENT "vpnclient_x64.exe"
  ${Else}
    StrCpy $SOFTETHER_VPNCLIENT "vpnclient.exe"
  ${EndIf}       

FunctionEnd


Section "SoftEther VPN Client" SEC01
 SetOutPath "$INSTDIR\backup.vpn_vpnclient.config"
 SetOverwrite try
 File "SoftEther VPN Client\backup.vpn_vpnclient.config\readme.txt"
 SetOutPath "$INSTDIR"
 File "SoftEther VPN Client\hamcore.se2"
 File "SoftEther VPN Client\installer.cache"
 File "SoftEther VPN Client\lang.config"
 File "SoftEther VPN Client\setuplog.dat"
 File "SoftEther VPN Client\vpnclient.exe"
 File "SoftEther VPN Client\vpnclient_x64.exe"
 File "SoftEther VPN Client\vpncmd.exe"
 File "SoftEther VPN Client\vpncmd_x64.exe"
 File "SoftEther VPN Client\vpncmgr.exe"
 CreateDirectory "$SMPROGRAMS\SoftEther VPN Client"
 CreateShortCut "$SMPROGRAMS\SoftEther VPN Client\SoftEther VPN Client Manager.lnk" "$INSTDIR\vpncmgr.exe"
 File "SoftEther VPN Client\vpncmgr_x64.exe"
 File "SoftEther VPN Client\vpninstall.exe"
 File "SoftEther VPN Client\vpnsetup.exe"
 File "SoftEther VPN Client\vpnweb.cab"
 File "SoftEther VPN Client\vpn_client.config"

 WriteRegStr HKCR ".vpn" "" "vpnfile"
 WriteRegStr HKCR "vpnfile" "" "VPN Client Connection Setting File"
 WriteRegStr HKCR "vpnfile\DefaultIcon" "" "C:\Program Files\SoftEther VPN Client\$SOFTETHER_VPNCLIENT"
 WriteRegStr HKCR "vpnfile\shell\open\command" "" "$\"C:\Program Files\SoftEther VPN Client\$SOFTETHER_VPNCLIENT$\" $\"%1$\""
 WriteRegBin HKLM "SOFTWARE\SoftEther Project\Network Settings" "LastMachineHash" f2852e5545015b7dbb6325fdef6ad11f03528434
 WriteRegDWORD HKLM "SOFTWARE\SoftEther Project\VPN Command Line Utility" "InstalledVersion" 0x24e9
 WriteRegStr HKLM "SOFTWARE\Classes\.vpn" "" "vpnfile"
 WriteRegStr HKLM "SOFTWARE\Classes\vpnfile" "" "VPN Client Connection Setting File"
 WriteRegStr HKLM "SOFTWARE\Classes\vpnfile\DefaultIcon" "" "C:\Program Files\SoftEther VPN Client\$SOFTETHER_VPNCLIENT"
 WriteRegStr HKLM "SOFTWARE\Classes\vpnfile\shell\open\command" "" "$\"C:\Program Files\SoftEther VPN Client\$SOFTETHER_VPNCLIENT$\" $\"%1$\""
 WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Run" "SoftEther VPN Client Manager" "$INSTDIR\vpncmgr.exe"

 ExecWait 'sc create SEVPNCLIENT binPath= "\"$INSTDIR\$SOFTETHER_VPNCLIENT\" /service" start= auto DisplayName= "SoftEther VPN Client"'
 ExecWait 'sc description SEVPNCLIENT "This manages the Virtual Network Adapter device driver and connection service for the SoftEther VPN Client. When this service is stopped, it will not be possible to use SoftEther VPN Client on this computer to connect to a SoftEther VPN Server."'
 ExecWait 'sc start SEVPNCLIENT'
 Sleep 10000

 FileOpen $4 "$INSTDIR\pulse2connection.vpncmd" w
 FileWrite $4 "NicCreate VPN$\r$\n"
 FileWrite $4 "AccountCreate $VPN_CONNECTION /SERVER:$VPN_SERVER:$VPN_PORT /HUB:$VPN_HUB /USERNAME:$VPN_LOGIN /NICNAME:VPN$\r$\n"
 FileWrite $4 "AccountPasswordSet $VPN_CONNECTION /PASSWORD:$VPN_PASSWORD /TYPE:standard$\r$\n"
 FileWrite $4 "AccountRetrySet $VPN_CONNECTION /NUM:0 /INTERVAL:5$\r$\n"
 FileWrite $4 "AccountConnect $VPN_CONNECTION$\r$\n"
 FileClose $4
 Exec '"$INSTDIR\vpncmgr.exe"'
 Sleep 10000
 ExecWait '"$INSTDIR\vpncmd.exe" localhost /CLIENT /IN:"$INSTDIR\pulse2connection.vpncmd"'
 Sleep 10000
 Delete "$INSTDIR\pulse2connection.vpncmd"

SectionEnd

Section -AdditionalIcons
 CreateShortCut "$SMPROGRAMS\SoftEther VPN Client\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
 WriteUninstaller "$INSTDIR\uninst.exe"
 WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\vpnclient.exe"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\vpnclient.exe"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
 WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
 HideWindow
 MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
 MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
 Abort
FunctionEnd

Function .onInstSuccess
  ${If} $REBOOT_AFTER_INSTALL == "true"
    ${IfNot} ${Silent}
      MessageBox MB_YESNO|MB_ICONEXCLAMATION "A reboot is required to finish the installation. Do you wish to reboot now?" IDNO +2
      Reboot
    ${Else}
      Reboot
    ${EndIf}
  ${EndIf}
FunctionEnd


Section Uninstall
 Delete "$INSTDIR\uninst.exe"
 Delete "$INSTDIR\vpn_client.config"
 Delete "$INSTDIR\vpnweb.cab"
 Delete "$INSTDIR\vpnsetup.exe"
 Delete "$INSTDIR\vpninstall.exe"
 Delete "$INSTDIR\vpncmgr_x64.exe"
 Delete "$INSTDIR\vpncmgr.exe"
 Delete "$INSTDIR\vpncmd_x64.exe"
 Delete "$INSTDIR\vpncmd.exe"
 Delete "$INSTDIR\vpnclient_x64.exe"
 Delete "$INSTDIR\vpnclient.exe"
 Delete "$INSTDIR\setuplog.dat"
 Delete "$INSTDIR\lang.config"
 Delete "$INSTDIR\installer.cache"
 Delete "$INSTDIR\hamcore.se2"
 Delete "$INSTDIR\backup.vpn_vpnclient.config\readme.txt"

 Delete "$SMPROGRAMS\SoftEther VPN Client\Uninstall.lnk"
 Delete "$SMPROGRAMS\SoftEther VPN Client\SoftEther VPN Client Manager.lnk"

 RMDir "$SMPROGRAMS\SoftEther VPN Client"
 RMDir "$INSTDIR\backup.vpn_vpnclient.config"
 RMDir "$INSTDIR"

 DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
 DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
 SetAutoClose true
SectionEnd
